From 48953c7981a8f280b2de501d934fde5247488acd Mon Sep 17 00:00:00 2001
From: Paul Marillonnet <pmarillonnet@entrouvert.com>
Date: Mon, 10 Jan 2022 18:51:53 +0100
Subject: [PATCH] add cantal theme (#60441)

---
 static/cantal/_custom.scss    |  81 ++++++++++++++++++++++++++++++++++
 static/cantal/_vars.scss      |  62 ++++++++++++++++++++++++++
 static/cantal/config.json     |  14 ++++++
 static/cantal/img/favicon.png | Bin 0 -> 1511 bytes
 static/cantal/style.scss      |   6 +++
 5 files changed, 163 insertions(+)
 create mode 100644 static/cantal/_custom.scss
 create mode 100644 static/cantal/_vars.scss
 create mode 100644 static/cantal/config.json
 create mode 100644 static/cantal/img/favicon.png
 create mode 100644 static/cantal/style.scss

diff --git a/static/cantal/_custom.scss b/static/cantal/_custom.scss
new file mode 100644
index 00000000..50ad14ec
--- /dev/null
+++ b/static/cantal/_custom.scss
@@ -0,0 +1,81 @@
+@media screen and (min-width: $mobile-limit + 1) {
+	div#toplinks {
+		right: 8em;
+		top: -35px;
+		border: none;
+		background: none;
+		box-shadow: none;
+		padding-top: 0.5em;
+		a {
+			color: white;
+		}
+	}
+
+	div#header-wrapper {
+		border-top: 35px solid $primary-color;
+	}
+
+	div#header h1#logo.has-logo {
+		padding-bottom: 20px;
+		a {
+			min-height: 70px;
+		}
+	}
+}
+
+div#nav {
+	@media screen and (max-width: $mobile-limit) {
+		padding-top: 20px;
+	}
+	@media screen and (min-width: $mobile-limit + 1) {
+		margin-top: 10px;
+		margin-bottom: 10px;
+		position: absolute;
+		top: 35px;
+		left: 24%;
+		ul {
+			li a {
+				line-height: 300%;
+				text-transform: uppercase;
+			}
+			margin-top: 0px;
+			margin-bottom: 0px;
+		}
+		a:hover {
+			text-decoration: underline;
+			text-decoration-color: black;
+			text-decoration-thickness: 2px;
+			text-underline-position: under;
+		}
+	}
+}
+
+div#main-content-wrapper {
+	max-width: 1260px;
+	@media screen and (min-width: $mobile-limit + 1) {
+		margin-top: 4em;
+	}
+}
+
+.gru-content div.link-list-cell,
+.gru-content div.link-list-cell.has-asset-picture > div picture img,
+.gru-content div.wcsformsofcategorycell,
+.gru-content div.wcsformsofcategorycell.has-asset-picture > div picture img,
+.gru-content div.wcsformsofcategorycell.has-asset-picture > div > h2:first-child {
+	border-radius: 20px;
+	overflow: hidden;
+	@media screen and (max-width: $mobile-limit) {
+		width: 100%;
+	}
+}
+
+div#footer-wrapper {
+	h1, h2, h3, h4, h5, h6 {
+		color: black;
+		background: $primary-color;
+	}
+	a:hover {
+		color: $primary-color-focus;
+		background: white;
+	}
+}
diff --git a/static/cantal/_vars.scss b/static/cantal/_vars.scss
new file mode 100644
index 00000000..c7d2eaa1
--- /dev/null
+++ b/static/cantal/_vars.scss
@@ -0,0 +1,62 @@
+$primary-color: #DD3333;
+$primary-color-focus: #B12929;
+
+$font-color: #676767;
+$font-family: "Raleway", "Open Sans", sans-serif;
+$link-color: $primary-color-focus;
+$border-radius: 0;
+$mobile-limit: 900px;
+$width: 100%;
+
+$nav-background: white;
+$nav-submenu-background: $primary-color-focus;
+$nav-submenu-color: white;
+$nav-color: $primary-color;
+$nav-active-color: $primary-color;
+$nav-item-selected-color: $primary-color;
+$nav-item-selected-background: white;
+$nav-item-hover-color: $primary-color-focus;
+$nav-item-hover-background: white;
+
+$button-color: white;
+$button-background: $primary-color;
+$button-border-radius: 2px;
+$button-hover-background: $primary-color-focus;
+
+$notification_warning_color: #F3E8A9;
+$notification_success_color: #abc600;
+$notification_info_color: #e4e4de;
+$notification_error_color: #cc3333;
+
+$sidebar-position: left;
+$sidebar-width: 275px;
+
+$title-weight: bold;
+$title-transform: uppercase;
+$title-font-size: 30px;
+$title-color: $primary-color-focus;
+$title-border-radius: 20px;
+
+$cell-title-cover-border: false;
+$cell-entry-color: $font-color;
+$cell-entry-hover-color: #444444;
+$cell-entry-hover-background: #f8f8f8;
+$cell-border-bottom: 1px solid #dd3333;
+$cell-border-radius: 2px;
+$cell-image-position: top;
+$cell-image-padding: none;
+
+$widget-border: none;
+$widget-border-radius: 2px;
+$widget-background: #f1f1f1;
+$widget-focus-background: #eaeaea;
+
+$footer-background: $primary-color;
+$footer-color: white;
+$footer-link-color: #CCCCCC;
+$footer-menucell-separator: none;
+
+$wcs-step-current-background: #f8f8f8;
+$wcs-step-current-border: 1px solid #dd3333;
+$wcs-step_color: grey;
+$wcs-step-border-bottom: 1px solid grey;
diff --git a/static/cantal/config.json b/static/cantal/config.json
new file mode 100644
index 00000000..875f1b20
--- /dev/null
+++ b/static/cantal/config.json
@@ -0,0 +1,14 @@
+{
+  "label": "Cantal (CD15)",
+  "variables": {
+    "favicon": "cantal/img/favicon.png",
+    "theme_color": "#dd3333"
+  },
+  "settings": {
+    "combo": {
+      "COMBO_ASSET_SLOTS.update": {
+        "header:logo": { "label": "Têtière : logo" }
+      }
+    }
+  }
+}
diff --git a/static/cantal/img/favicon.png b/static/cantal/img/favicon.png
new file mode 100644
index 0000000000000000000000000000000000000000..c8ffe98c05ae7cd07c8bcbb6a214574c7816872c
GIT binary patch
diff --git a/static/cantal/style.scss b/static/cantal/style.scss
new file mode 100644
index 00000000..96e6b295
--- /dev/null
+++ b/static/cantal/style.scss
@@ -0,0 +1,6 @@
+@charset "UTF-8";
+
+@import '../includes/fonts/raleway';
+@import 'vars';
+@import '../includes/publik';
+@import 'custom';
-- 
2.34.1